COMPOSE_RUN = docker-compose run --rm
TERRAFORM = $(COMPOSE_RUN) terraform
CI_TF_ARGS = --input=false


ifdef GOOGLE_APPLICATION_CREDENTIALS
COMPOSE_RUN += -v $(GOOGLE_APPLICATION_CREDENTIALS):$(GOOGLE_APPLICATION_CREDENTIALS)
endif


pull:
	docker-compose pull
init: pull init_raw
init_raw:
	$(TERRAFORM) init $(TF_ARGS) \
		--backend-config=bucket=$(TF_VAR_tf_backend_bucket) \
    --backend-config=prefix=polls
plan:
	$(TERRAFORM) plan $(TF_ARGS)
apply:
	$(TERRAFORM) apply $(TF_ARGS)
destroy:
	$(TERRAFORM) destroy


create_workspaces: init
	$(TERRAFORM) workspace new dev || true
	$(TERRAFORM) workspace new prod || true


init_ci: TERRAFORM = terraform
init_ci: TF_ARGS += $(CI_TF_ARGS)
init_ci: init_raw

plan_ci: TERRAFORM = terraform
plan_ci: TF_ARGS += $(CI_TF_ARGS) --out=out.tfplan
plan_ci: plan

apply_ci: TERRAFORM = terraform
apply_ci: TF_ARGS += $(CI_TF_ARGS) --auto-approve out.tfplan
apply_ci: apply
